<template lang="pug">
div
  .row
    .col-auto
      q-toggle(
        v-model="visible",
        @input="updateVisible()",
        :disable="!hasSlug"
      )
        q-tooltip Make visible
    .col
      .row
        ais-instant-search.col(
          :search-client="searchClient",
          index-name="Contents"
        )
          ais-search-box(
            placeholder="Search PIP Content...",
            show-loading-indicator
          )
            template(v-slot="{ currentRefinement, isSearchStalled, refine }")
              q-input(
                dense,
                rounded,
                outlined,
                placeholder="Search Partners in Parenting",
                v-model="currentRefinement",
                @input="openMenu(currentRefinement); refine(currentRefinement)",
                :loading="isSearchStalled"
              )

          q-menu(auto-close, fit, v-model="opened", no-focus)
            ais-hits
              template(v-slot="{ items, sendEvent }")
                q-list
                  div(v-for="item in items", :key="item.objectID")
                    //- div {{ item }}
                    q-item(clickable, @click="select(item)") 
                      q-item-section
                        q-item-label
                          ais-highlight.text-bold(
                            attribute="title",
                            :hit="item"
                          )
                          ais-highlight.ellipsis-2-lines(
                            attribute="excerpt",
                            :hit="item"
                          )
                        q-item-label.text-capitalize(caption) {{ getTitle(item.path) }}
                    q-separator
          //- ais-stats(:class-names="{ 'ais-Stats-text': 'MyCustomStatsText' }")
      .col(v-if="plugin && plugin.selected && plugin.selected")
        .row.items-center
          q-icon.on-left(name="article")
          span.text-bold {{ plugin.selected.title }}
          span.q-mx-xs &middot;
          .text-grey-6.text-capitalize {{ getTitle(plugin.selected.path) }}
</template>

<script>
import {
  AisInstantSearch,
  AisSearchBox,
  AisHits,
  AisStats,
  AisHighlight,
} from "vue-instantsearch";

import "instantsearch.css/themes/reset-min.css";

import algoliasearch from "algoliasearch/lite";

export default {
  name: "PipSearchDashboard",
  components: {
    AisInstantSearch,
    AisSearchBox,
    AisHits,
    AisHighlight,
    AisStats,
  },
  props: {
    firebase: {
      required: true,
    },
    context: {
      required: false,
    },
  },
  computed: {
    hasSlug() {
      console.log(this.plugin.selected);
      return this.plugin.selected && this.plugin.selected.path;
    },
  },
  created() {},
  data: () => {
    return {
      opened: false,
      visible: false,
      plugin: {},
      searchClient: algoliasearch(
        "M6Q5VGADXZ",
        "cbd2a018fa90b3c350b30994802fa128"
      ),
    };
  },
  methods: {
    getTitle(title) {
      // console.log(title);
      return title
        .replace(/^\/m\d-/, "")
        .replace(/-/g, " ")
        .replace(/\/\d\d/, " - ");
    },
    openMenu(val) {
      if (val.length) {
        this.opened = true;
        // console.log("open");
      }
    },
    async select(item) {
      this.opened = false;
      await this.firebase
        .ref(
          `config/${this.context.meetingid}/current/currentState/plugins/pipsearch/selected`
        )
        .set(item);
    },
    async updateVisible() {
      await this.firebase
        .ref(
          `config/${this.context.meetingid}/current/currentState/plugins/pipsearch/visible`
        )
        .set(this.visible);
    },
    async updateHighlight() {
      await this.firebase
        .ref(
          `config/${this.context.meetingid}/current/currentState/plugins/pipsearch/highlight`
        )
        .set(this.plugin.highlight);
    },
  },
  watch: {
    plugin: {
      handler(nue, old) {
        if (nue.visible != old.visible) {
          this.visible = this.plugin.visible;
          if (typeof this.visible == "undefined") this.visible = false;
        }
      },
    },
    firebase: {
      immediate: true,
      async handler() {
        await this.$rtdbBind(
          "plugin",
          this.firebase.ref(
            `config/${this.context.meetingid}/current/currentState/plugins/pipsearch`
          )
        );
        this.visible = this.plugin.visible;

        if (typeof this.visible == "undefined") this.visible = false;
        // console.log(this.plugin);
        // console.log(this.visible);
      },
    },
  },
};
</script>
<style lang="scss" scoped>
.progress {
  position: absolute;
  bottom: -10px;
  left: -10px;
  filter: drop-shadow(0 0 10px black);
}
.MyCustomStatsText {
  font-size: 0.8em;
}
</style>
